import {Component, isDevMode} from '@angular/core';

export function AiutComponent(args: any = {}): (cls: any) => any {
  const ngCompDecorator = Component(args);

  return function (compType: any) {
    ngCompDecorator(compType);

    if (isDevMode()) {
      const orignalChange = compType.ngOnChange;

      compType.ngOnChange = () => {
        console.info(`${compType.constructor.name} changed`);

        orignalChange.call(compType);
      };
    }
  };
}
